import { ExposeOptions, ExcludeOptions } from "./metadata/ExposeExcludeOptions";
/**
 * Specifies a type of the property.
 */
export declare function Type(typeFunction?: (type?: any) => Function): (target: any, key: string) => void;
/**
 * Marks property as included in the process of transformation. By default it includes the property for both
 * constructorToPlain and plainToConstructor transformations, however you can specify on which of transformation types
 * you want to skip this property.
 */
export declare function Expose(options?: ExposeOptions): (object: Object | Function, propertyName?: string) => void;
/**
 * Marks property as excluded from the process of transformation. By default it excludes the property for both
 * constructorToPlain and plainToConstructor transformations, however you can specify on which of transformation types
 * you want to skip this property.
 */
export declare function Exclude(options?: ExcludeOptions): (object: Object | Function, propertyName?: string) => void;
